<template>
  <div class="container-fluid g-0">
    <Header class="row g-0"/>
    <main class="row g-0">
      <div class="col sidebar">
         <i class="tirette fa fa-ellipsis-v fa-lg fa-fw"></i>
         <Sidebar />
      </div>
      <div class="col content" v-if="content === 'map' && store.state.map">
         <Modal />
         <AppMap />
      </div>
      <div class="col content" v-if="content === 'chart'">
        <div v-if="message" class="no-data-container">
           <p class="error-msg">{{ message }}</p>
        </div>
        <div v-else>
          <Modal />
          <PlotlyChart />
        </div>
      </div>
    </main>
    <div class="row g-0 footer">
      <Footer />
    </div>
  </div>
</template>

<script lang="ts">
import {defineComponent, computed, onMounted} from 'vue'
import Modal from '../components/Modal.vue'
import AppMap from '../components/AppMap.vue'
import PlotlyChart from '../components/PlotlyChart.vue'
import Header from '../components/Header.vue'
import Footer from '../components/Footer.vue'
import Sidebar from '../components/Sidebar.vue'

import { useStore } from '@/store'

export default defineComponent({
  name: 'HomeView',
  components: { AppMap, Header, Footer, Sidebar, PlotlyChart, Modal },
  props: ['zoom', 'center'],
  setup: (props) => {

    // STORE
    const store = useStore();

    onMounted(() => {
      if (typeof props.zoom !== 'undefined' && typeof props.center !== 'undefined') {
        store.state.map.getView().setZoom(props.zoom);
        store.state.map.getView().setCenter(props.center.split(","));
      } else {
        store.state.map.getView().setZoom(store.state.currentZoom);
        store.state.map.getView().setCenter(store.state.currentCenter);
      }
    })

    return {
      store,
      // store variables
      content:  computed(() => store.state.content),
      message: computed(() => store.state.message)
    }
  }
})
</script>
